import java.io.*;
import java.security.*;
import java.net.*;
import javax.crypto.*;

public class ServerSecrets {
    private String        AMHost;
    private int           AMPort;
    private ServerKeyPair skp;
    private SecretKey     skey;
    private String        id;

    public ServerSecrets(String i, String host, int port, ServerKeyPair sk) {
        id = i;
        AMHost = host;
        AMPort = port;
        skp = sk;
    }

    public boolean init() {
        ServerSecuredComm ssc;

        try {
            Socket socket = new Socket(AMHost, AMPort);
            ssc = new ServerSecuredComm(socket, skp);
            if (ssc.initA()) {
                ssc.getObjectOutputStream().writeObject(new Integer(id));
                ssc.done();
                skey = ssc.getSecretKey();
                return true;
            }
        } catch (Exception e) {
            System.err.println("ServerSecrets: init() Exception-> " + e);
        }
        ssc = null;
        skey = null;
        return false;
    }

    public SecretKey getSecretKey() {
        return this.skey;
    }
}
